
/******************************************************************************
* MODULE     : series_test.cc
* DESCRIPTION: Test series
* COPYRIGHT  : (C) 2004  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "rational.hpp"
#include "series.hpp"
using namespace mml;

rational fun (nat n) { return 1; }

int
main () {
  series<rational> f (3, 5);
  series<rational> g (fun, "fun");
  cout << "f\t= " << f << "\n";
  cout << "g\t= " << g << "\n";
  cout << "f\t= " << f << "\n";
  cout << "g\t= " << g << "\n";
  cout << "-f\t= " << -f << "\n";
  cout << "f+g\t= " << f+g << "\n";
  cout << "f-g\t= " << f-g << "\n";
  cout << "g-f\t= " << g-f << "\n";
  cout << "f*g\t= " << f*g << "\n";
  cout << "2*f\t= " << 2*f << "\n";
  cout << "f*2\t= " << f*2 << "\n";
  cout << "f/3\t= " << f/3 << "\n";
  cout << "f+=g\t= " << (f+=g) << "\n";
  cout << "f-=g\t= " << (f-=g) << "\n";
  //cout << "f*=g\t= " << (f*=g) << "\n";
  //cout << "f/=g\t= " << (f/=g) << "\n";
  cout << "f*=11\t= " << (f*=11) << "\n";
  cout << "f/=11\t= " << (f/=11) << "\n";
  cout << "f<<2\t= " << (f<<2) << "\n";
  cout << "f>>2\t= " << (f>>2) << "\n";
  cout << "g<<2\t= " << (g<<2) << "\n";
  cout << "g>>2\t= " << (g>>2) << "\n";
  cout << "g o z^3\t= " << dilate (g, 3) << "\n";
  cout << "g'\t= " << derive (g) << "\n";
  cout << "`g\t= " << integrate (g) << "\n";
  cout << "f=g\t= " << (f==g) << "\n";
  cout << "f!=g\t= " << (f!=g) << "\n";
  cout << "f<g\t= " << (f<g) << "\n";
  cout << "f<=g\t= " << (f<=g) << "\n";
  cout << "f>g\t= " << (f>g) << "\n";
  cout << "f>=g\t= " << (f>=g) << "\n";
  return 0;
}
